Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8486)
@@ -17,5 +17,5 @@
    PRIVATE
 
-   PUBLIC    ice_alloc  !  Called in ice_init
+   PUBLIC    ice_alloc  ! called by icestp.F90
 
    !!======================================================================
@@ -288,10 +288,12 @@
    REAL(wp), PUBLIC ::   r1_nlay_s        !: 1 / nlay_s 
    REAL(wp), PUBLIC ::   rswitch          !: switch for the presence of ice (1) or not (0)
-   REAL(wp), PUBLIC, PARAMETER ::   epsi06   = 1.e-06_wp  !: small number 
-   REAL(wp), PUBLIC, PARAMETER ::   epsi10   = 1.e-10_wp  !: small number 
-   REAL(wp), PUBLIC, PARAMETER ::   epsi20   = 1.e-20_wp  !: small number 
+   REAL(wp), PUBLIC, PARAMETER ::   epsi06 = 1.e-06_wp  !: small number 
+   REAL(wp), PUBLIC, PARAMETER ::   epsi10 = 1.e-10_wp  !: small number 
+   REAL(wp), PUBLIC, PARAMETER ::   epsi20 = 1.e-20_wp  !: small number 
+   !
+   LOGICAL , PUBLIC ::   l_piling         !: =T simple conservative piling, comparable with LIM2
 
    !                                     !!** define arrays
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   u_oce, v_oce !: surface ocean velocity used in ice dynamics
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   u_oce,v_oce !: surface ocean velocity used in ice dynamics
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   hicol       !: ice collection thickness accreted in leads
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   strength    !: ice strength
@@ -499,5 +501,5 @@
    !
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2010)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice1D.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice1D.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice1D.F90	(revision 8486)
@@ -8,14 +8,15 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
-   !!----------------------------------------------------------------------
+   !!   'key_lim3'                                       LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   USE ice     , ONLY :   nlay_i, nlay_s, jpl   ! number of ice/snow layers and categories
+   !
    USE in_out_manager ! I/O manager
    USE lib_mpp        ! MPP library
-   USE ice, ONLY :   nlay_i, nlay_s, jpl
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC ice1D_alloc ! Routine called by nemogcm.F90
+   PUBLIC   ice1D_alloc   ! called by icestp.F90
 
    !!----------------------
@@ -26,4 +27,6 @@
    !: are the variables corresponding to 2d vectors
 
+!! please, DOCTOR naming convention   starting by i means LOCAL integer
+!!         ===>>>  rename idxice  as nidice or nidthd, or nidx_thd or midx ... ?
    INTEGER , PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) ::   idxice !: selected points for ice thermo
    INTEGER , PUBLIC                                  ::   nidx   !  number of selected points
@@ -151,5 +154,5 @@
    
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: ice1D.F90 8379 2017-07-26 15:35:49Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv.F90	(revision 8486)
@@ -10,24 +10,23 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
-   !!----------------------------------------------------------------------
-   !!   ice_adv      : advection/diffusion process of sea ice
+   !!   'key_lim3'                                       LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   ice_adv       : advection/diffusion process of sea ice
    !!----------------------------------------------------------------------
    USE phycst         ! physical constant
    USE dom_oce        ! ocean domain
-   USE sbc_oce , ONLY : nn_fsbc
-   USE ice            ! ice variables
-   USE icevar         ! 
-   USE iceadv_prather ! advection scheme (Prather)
-   USE iceadv_umx     ! advection scheme (ultimate-macho)
+   USE sbc_oce , ONLY : nn_fsbc   ! frequency of sea-ice call
+   USE ice            ! sea-ice: variables
+   USE icevar         ! sea-ice: operations
+   USE iceadv_prather ! sea-ice: advection scheme (Prather)
+   USE iceadv_umx     ! sea-ice: advection scheme (ultimate-macho)
+   USE icectl         ! sea-ice: control prints
    !
    USE in_out_manager ! I/O manager
    USE lbclnk         ! lateral boundary conditions -- MPP exchanges
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! work arrays
    USE prtctl         ! Print control
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
    USE timing         ! Timing
-   USE icectl         ! control prints
 
    IMPLICIT NONE
@@ -36,10 +35,10 @@
    PUBLIC   ice_adv    ! called by icestp
 
-   INTEGER  ::   ncfl                 ! number of ice time step with CFL>1/2  
+   INTEGER ::   ncfl   ! number of ice time step with CFL>1/2  
 
    !! * Substitution
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: iceadv.F90 8373 2017-07-25 17:44:54Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -48,5 +47,5 @@
 
    SUBROUTINE ice_adv( kt ) 
-      !!-------------------------------------------------------------------
+      !!----------------------------------------------------------------------
       !!                   ***  ROUTINE ice_adv ***
       !!                    
@@ -60,5 +59,5 @@
       !!
       !! ** action :
-      !!---------------------------------------------------------------------
+      !!----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt   ! number of iteration
       !
@@ -73,16 +72,15 @@
       REAL(wp), DIMENSION(jpi,jpj,jpl)       ::   zhimax, zviold, zvsold
       ! --- ultimate macho only --- !
-      REAL(wp)                               ::   zdt
-      REAL(wp), POINTER, DIMENSION(:,:)      ::   zudy, zvdx, zcu_box, zcv_box
+      REAL(wp) ::   zdt
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)      ::   zudy, zvdx, zcu_box, zcv_box
       ! --- prather only --- !
-      REAL(wp), POINTER, DIMENSION(:,:)      ::   zarea
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   z0opw
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   z0ice, z0snw, z0ai, z0es , z0smi , z0oi
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)     ::   zarea
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   z0opw
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   z0ice, z0snw, z0ai, z0es , z0smi , z0oi
       ! MV MP 2016
-      REAL(wp), POINTER, DIMENSION(:,:,:)    ::   z0ap , z0vp
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   z0ap , z0vp
       REAL(wp) ::   za_old
       ! END MV MP 2016
-      REAL(wp), POINTER, DIMENSION(:,:,:,:)  ::   z0ei
-      !!
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   z0ei
       !!---------------------------------------------------------------------
       IF( nn_timing == 1 )  CALL timing_start('iceadv')
@@ -90,6 +88,6 @@
       IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)''
-         WRITE(numout,*)'iceadv'
-         WRITE(numout,*)'~~~~~~'
+         WRITE(numout,*)'iceadv : sea-ice advection'
+         WRITE(numout,*)'~~~~~~~'
          ncfl = 0                ! nb of time step with CFL > 1/2
       ENDIF
@@ -127,4 +125,5 @@
          DO jj = 2, jpjm1
             DO ji = 2, jpim1
+!!gm use of MAXVAL here is very probably less efficient than expending the 9 values
                zhimax(ji,jj,jl) = MAXVAL( ht_i(ji-1:ji+1,jj-1:jj+1,jl) + ht_s(ji-1:ji+1,jj-1:jj+1,jl) )
             END DO
@@ -156,5 +155,5 @@
                        !=============================!
       
-         CALL wrk_alloc( jpi,jpj, zudy, zvdx, zcu_box, zcv_box )
+         ALLOCATE( zudy(jpi,jpj) , zvdx(jpi,jpj) , zcu_box(jpi,jpj) , zcv_box(jpi,jpj) )
       
          IF( kt == nit000 .AND. lwp ) THEN
@@ -212,5 +211,5 @@
          END DO
          !
-         CALL wrk_dealloc( jpi,jpj, zudy, zvdx, zcu_box, zcv_box )
+         DEALLOCATE( zudy, zvdx, zcu_box, zcv_box )
          
                        !=============================!
@@ -218,9 +217,8 @@
                        !=============================!
 
-         CALL wrk_alloc( jpi,jpj,            zarea )
-         CALL wrk_alloc( jpi,jpj,1,          z0opw )
-         CALL wrk_alloc( jpi,jpj,jpl,        z0ice, z0snw, z0ai, z0es , z0smi , z0oi )
-         CALL wrk_alloc( jpi,jpj,jpl,        z0ap , z0vp )
-         CALL wrk_alloc( jpi,jpj,nlay_i,jpl, z0ei )
+         ALLOCATE( zarea(jpi,jpj)     , z0opw(jpi,jpj, 1 ) ,                                           &
+            &      z0ice(jpi,jpj,jpl) , z0snw(jpi,jpj,jpl) , z0ai(jpi,jpj,jpl) , z0es(jpi,jpj,jpl) ,   &
+            &      z0smi(jpi,jpj,jpl) , z0oi (jpi,jpj,jpl) , z0ap(jpi,jpj,jpl) , z0vp(jpi,jpj,jpl) ,   &
+            &      z0ei (jpi,jpj,nlay_i,jpl)                                                           )
          
          IF( kt == nit000 .AND. lwp ) THEN
@@ -237,22 +235,20 @@
          z0opw(:,:,1) = ato_i(:,:) * e1e2t(:,:)             ! Open water area 
          DO jl = 1, jpl
-            z0snw (:,:,jl)  = v_s  (:,:,  jl) * e1e2t(:,:)  ! Snow volume
-            z0ice(:,:,jl)   = v_i  (:,:,  jl) * e1e2t(:,:)  ! Ice  volume
-            z0ai  (:,:,jl)  = a_i  (:,:,  jl) * e1e2t(:,:)  ! Ice area
-            z0smi (:,:,jl)  = smv_i(:,:,  jl) * e1e2t(:,:)  ! Salt content
-            z0oi (:,:,jl)   = oa_i (:,:,  jl) * e1e2t(:,:)  ! Age content
-            z0es (:,:,jl)   = e_s  (:,:,1,jl) * e1e2t(:,:)  ! Snow heat content
+            z0snw(:,:,jl) = v_s  (:,:,  jl) * e1e2t(:,:)  ! Snow volume
+            z0ice(:,:,jl) = v_i  (:,:,  jl) * e1e2t(:,:)  ! Ice  volume
+            z0ai (:,:,jl) = a_i  (:,:,  jl) * e1e2t(:,:)  ! Ice area
+            z0smi(:,:,jl) = smv_i(:,:,  jl) * e1e2t(:,:)  ! Salt content
+            z0oi (:,:,jl) = oa_i (:,:,  jl) * e1e2t(:,:)  ! Age content
+            z0es (:,:,jl) = e_s  (:,:,1,jl) * e1e2t(:,:)  ! Snow heat content
             DO jk = 1, nlay_i
-               z0ei  (:,:,jk,jl) = e_i  (:,:,jk,jl) * e1e2t(:,:) ! Ice  heat content
+               z0ei(:,:,jk,jl) = e_i(:,:,jk,jl) * e1e2t(:,:) ! Ice  heat content
             END DO
             ! MV MP 2016
             IF ( nn_pnd_scheme > 0 ) THEN
-               z0ap  (:,:,jl)  = a_ip (:,:,jl) * e1e2t(:,:) ! Melt pond fraction
-               z0vp  (:,:,jl)  = v_ip (:,:,jl) * e1e2t(:,:) ! Melt pond volume
+               z0ap(:,:,jl)  = a_ip(:,:,jl) * e1e2t(:,:) ! Melt pond fraction
+               z0vp(:,:,jl)  = v_ip(:,:,jl) * e1e2t(:,:) ! Melt pond volume
             ENDIF
             ! END MV MP 2016
-
-         END DO
-
+         END DO
 
          IF( MOD( ( kt - 1) / nn_fsbc , 2 ) == 0 ) THEN       !==  odd ice time step:  adv_x then adv_y  ==!
@@ -383,18 +379,12 @@
             ! END MV MP 2016
          END DO
-
+         !
          at_i(:,:) = a_i(:,:,1)      ! total ice fraction
          DO jl = 2, jpl
             at_i(:,:) = at_i(:,:) + a_i(:,:,jl)
          END DO
-         
-         CALL wrk_dealloc( jpi,jpj,            zarea )
-         CALL wrk_dealloc( jpi,jpj,1,          z0opw )
-         CALL wrk_dealloc( jpi,jpj,jpl,        z0ice, z0snw, z0ai, z0es , z0smi , z0oi )
-         ! MV MP 2016
-         CALL wrk_dealloc( jpi,jpj,jpl,        z0ap , z0vp )
-         ! END MV MP 2016
-         CALL wrk_dealloc( jpi,jpj,nlay_i,jpl, z0ei )
-
+         !
+         DEALLOCATE( zarea , z0opw , z0ice, z0snw , z0ai , z0es , z0smi , z0oi , z0ap , z0vp , z0ei )
+         !
       END SELECT
       
@@ -411,27 +401,25 @@
       
       IF( nn_limdyn == 2) THEN
-
-         ! zap small areas
-         CALL ice_var_zapsmall
-           
-         !--- Thickness correction in case too high --- !
-         DO jl = 1, jpl
+         !
+         CALL ice_var_zapsmall      !--- zap small areas ---!
+         !
+         DO jl = 1, jpl             !--- Thickness correction in case too high --- !
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  
+                  ! 
                   IF ( v_i(ji,jj,jl) > 0._wp ) THEN
-                     
+                     !
                      rswitch          = MAX( 0._wp , SIGN( 1._wp, a_i(ji,jj,jl) - epsi20 ) )
                      ht_i  (ji,jj,jl) = v_i (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi20 ) * rswitch
                      ht_s  (ji,jj,jl) = v_s (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi20 ) * rswitch
-                     
+                     !
                      zdv  = v_i(ji,jj,jl) + v_s(ji,jj,jl) - zviold(ji,jj,jl) - zvsold(ji,jj,jl)  
-                     
+                     !
                      IF ( ( zdv >  0.0 .AND. (ht_i(ji,jj,jl)+ht_s(ji,jj,jl)) > zhimax(ji,jj,jl) .AND. zatold(ji,jj) < 0.80 ) .OR. &
                         & ( zdv <= 0.0 .AND. (ht_i(ji,jj,jl)+ht_s(ji,jj,jl)) > zhimax(ji,jj,jl) ) ) THEN
-                        
+                        !
                         rswitch        = MAX( 0._wp, SIGN( 1._wp, zhimax(ji,jj,jl) - epsi20 ) )
                         a_i(ji,jj,jl)  = rswitch * ( v_i(ji,jj,jl) + v_s(ji,jj,jl) ) / MAX( zhimax(ji,jj,jl), epsi20 )
-                        
+                        !
                         ! small correction due to *rswitch for a_i
                         v_i  (ji,jj,jl)        = rswitch * v_i  (ji,jj,jl)
@@ -447,16 +435,14 @@
                         ENDIF
                         ! END MV MP 2016
-                                                
+                        !
                      ENDIF
-                     
+                     !
                   ENDIF
-                
+                  !
                END DO
             END DO
          END DO
-         ! -------------------------------------------------
-         
-         ! Force the upper limit of ht_i to always be < hi_max (99 m).
-         DO jj = 1, jpj
+         
+         DO jj = 1, jpj             !--- bound ht_i to hi_max (99 m).
             DO ji = 1, jpi
                ! MV MP 2016
@@ -474,6 +460,5 @@
             END DO
          END DO
-
-
+         !
       ENDIF
          
@@ -482,16 +467,24 @@
       !------------------------------------------------------------
       !
-      at_i(:,:) = SUM( a_i(:,:,:), dim=3 )
-      IF ( nn_limdyn == 1 .OR. ( ( nn_monocat == 2 ) .AND. ( jpl == 1 ) ) ) THEN ! simple conservative piling, comparable with LIM2
+!!gm remplace the test by, l_piling a logical compute one for all in icestp.F90 (and its declaration in ice.F90
+!!gm      IF ( nn_limdyn == 1 .OR. ( ( nn_monocat == 2 ) .AND. ( jpl == 1 ) ) ) THEN ! simple conservative piling, comparable with LIM2
+      IF( l_piling ) THEN
+         at_i(:,:) = SUM( a_i(:,:,:), dim=3 )
          DO jl = 1, jpl
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  rswitch       = MAX( 0._wp, SIGN( 1._wp, at_i(ji,jj) - epsi20 ) )
-                  zda           = rswitch * MIN( rn_amax_2d(ji,jj) - at_i(ji,jj), 0._wp )  &
-                     &                    * a_i(ji,jj,jl) / MAX( at_i(ji,jj), epsi20 )
+                  rswitch = MAX( 0._wp, SIGN( 1._wp, at_i(ji,jj) - epsi20 ) )
+                  zda     = rswitch * MIN( rn_amax_2d(ji,jj) - at_i(ji,jj), 0._wp ) * a_i(ji,jj,jl) / MAX( at_i(ji,jj), epsi20 )
                   a_i(ji,jj,jl) = a_i(ji,jj,jl) + zda
                END DO
             END DO
          END DO
+!!gm better and faster coding?
+!         DO jl = 1, jpl
+!            WHERE( at_i(:,:) > epsi20 )
+!               a_i(:,:,jl) = a_i(:,:,jl) * (  1._wp + MIN( rn_amax_2d(:,:) - at_i(:,:) , 0._wp ) / at_i(:,:)  )
+!            END WHERE
+!         END DO
+!!gm end
       ENDIF
       
@@ -527,8 +520,6 @@
    !!   Default option         Empty Module                No sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_adv        ! Empty routine
-   END SUBROUTINE ice_adv
 #endif
+
    !!======================================================================
 END MODULE iceadv
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_prather.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_prather.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_prather.F90	(revision 8486)
@@ -5,22 +5,22 @@
    !!======================================================================
    !! History :  LIM  ! 2008-03 (M. Vancoppenolle)  LIM-3 from LIM-2 code
-   !!            3.2  ! 2009-06 (F. Dupont)  correct a error in the North fold b. c.
+   !!            3.2  ! 2009-06 (F. Dupont)  correct a error in the North fold b.c.
    !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
    !!--------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                     LIM3 sea-ice model
-   !!----------------------------------------------------------------------
-   !!   ice_adv_x  : advection of sea ice on x axis
-   !!   ice_adv_y  : advection of sea ice on y axis
-   !!----------------------------------------------------------------------
-   USE dom_oce          ! ocean domain
-   USE ice              ! LIM-3 variables
+   !!   'key_lim3'                                       LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   ice_adv_x     : advection of sea ice on x axis
+   !!   ice_adv_y     : advection of sea ice on y axis
+   !!----------------------------------------------------------------------
+   USE dom_oce        ! ocean domain
+   USE ice            ! sea-ice variables
    !
-   USE lbclnk           ! lateral boundary condition - MPP exchanges
-   USE in_out_manager   ! I/O manager
-   USE prtctl           ! Print control
-   USE lib_mpp          ! MPP library
-   USE lib_fortran      ! to use key_nosignedzero
+   USE lbclnk         ! lateral boundary condition - MPP exchanges
+   USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
+   USE lib_mpp        ! MPP library
+   USE lib_fortran    ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -33,5 +33,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: iceadv.F90 6746 2016-06-27 17:20:57Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -41,5 +41,5 @@
    SUBROUTINE ice_adv_x( pdf, put , pcrh, psm , ps0 ,   &
       &                  psx, psxx, psy , psyy, psxy )
-      !!---------------------------------------------------------------------
+      !!----------------------------------------------------------------------
       !!                **  routine ice_adv_x  **
       !!  
@@ -52,5 +52,5 @@
       !!
       !! Reference:  Prather, 1986, JGR, 91, D6. 6671-6681.
-      !!--------------------------------------------------------------------
+      !!----------------------------------------------------------------------
       REAL(wp)                    , INTENT(in   ) ::   pdf                ! reduction factor for the time step
       REAL(wp)                    , INTENT(in   ) ::   pcrh               ! call ice_adv_x then ice_adv_y (=1) or the opposite (=0)
@@ -68,5 +68,5 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   zfm , zfxx , zfyy  , zfxy   !  -      -
       REAL(wp), DIMENSION(jpi,jpj) ::   zalg, zalg1, zalg1q         !  -      -
-      !---------------------------------------------------------------------
+      !-----------------------------------------------------------------------
 
       ! Limitation of moments.                                           
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_umx.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_umx.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceadv_umx.F90	(revision 8486)
@@ -4,21 +4,19 @@
    !! LIM sea-ice model : sea-ice advection using the ULTIMATE-MACHO scheme
    !!==============================================================================
-   !! History :  3.5  !  2014-11  (C. Rousset, G. Madec)  Original code
-   !!----------------------------------------------------------------------
-
+   !! History :  3.6  !  2014-11  (C. Rousset, G. Madec)  Original code
+   !!----------------------------------------------------------------------
+#if defined key_lim3
+   !!----------------------------------------------------------------------
+   !!   'key_lim3'                                    LIM 3.0 sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_adv_umx   : update the tracer trend with the 3D advection trends using a TVD scheme
-   !!   ultimate      : compute a tracer value at velocity points using ULTIMATE scheme at various orders
-   !!   macho         : 
+   !!   ultimate_x(_y): compute a tracer value at velocity points using ULTIMATE scheme at various orders
+   !!   macho         : ???
    !!   nonosc_2d     : compute monotonic tracer fluxes by a non-oscillatory algorithm 
-   !!----------------------------------------------------------------------
-#if defined key_lim3
-   !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                  LIM 3.0 sea-ice model
    !!----------------------------------------------------------------------
    USE phycst         ! physical constant
    USE dom_oce        ! ocean domain
-   USE sbc_oce, ONLY: nn_fsbc   ! ocean surface boundary condition
-   USE ice            ! ice variables
+   USE sbc_oce , ONLY : nn_fsbc   ! update frequency of surface boundary condition
+   USE ice            ! sea-ice variables
    !
    USE in_out_manager ! I/O manager
@@ -33,11 +31,11 @@
    PUBLIC   ice_adv_umx    ! routine called by iceadv.F90
       
-   REAL(wp) ::   z1_6   = 1._wp / 6._wp   ! =1/6
-   REAL(wp) ::   z1_120 = 1._wp / 120._wp ! =1/120
+   REAL(wp) ::   z1_6   = 1._wp /   6._wp   ! =1/6
+   REAL(wp) ::   z1_120 = 1._wp / 120._wp   ! =1/120
 
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: iceadv_umx.F90 4499 2014-02-18 15:14:31Z timgraham $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -58,9 +56,9 @@
       !! ** Action : - pt  the after advective tracer
       !!----------------------------------------------------------------------
-      INTEGER                     , INTENT(in   )           ::   kt         ! number of iteration
-      REAL(wp)                    , INTENT(in   )           ::   pdt        ! tracer time-step
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   )           ::   puc, pvc   ! 2 ice velocity components => u*e2
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   )           ::   pubox, pvbox   ! upstream velocity
-      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout)           ::   ptc        ! tracer content field
+      INTEGER                     , INTENT(in   ) ::   kt             ! number of iteration
+      REAL(wp)                    , INTENT(in   ) ::   pdt            ! tracer time-step
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   puc  , pvc     ! 2 ice velocity components => u*e2
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in   ) ::   pubox, pvbox   ! upstream velocity
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(inout) ::   ptc            ! tracer content field
       !
       INTEGER  ::   ji, jj           ! dummy loop indices  
@@ -68,5 +66,6 @@
       REAL(wp) ::   zfp_ui, zfp_vj   !   -      -
       REAL(wp) ::   zfm_ui, zfm_vj   !   -      -
-      REAL(wp), DIMENSION(jpi,jpj) :: zt_ups, zfu_ups, zfv_ups, ztrd, zfu_ho, zfv_ho, zt_u, zt_v
+      REAL(wp), DIMENSION(jpi,jpj) ::   zfu_ups, zfu_ho, zt_u, zt_ups
+      REAL(wp), DIMENSION(jpi,jpj) ::   zfv_ups, zfv_ho, zt_v, ztrd
       !!----------------------------------------------------------------------
       !
@@ -394,7 +393,6 @@
       !
       SELECT CASE (k_order )
-         !
-      CASE( 1 )                                                   !==  1st order central TIM  ==! (Eq. 21)
-         !        
+      !
+      CASE( 1 )                                                !==  1st order central TIM  ==! (Eq. 21)
          DO jj = 1, jpjm1
             DO ji = 1, jpi
@@ -404,5 +402,5 @@
          END DO
          !
-      CASE( 2 )                                                   !==  2nd order central TIM  ==! (Eq. 23)
+      CASE( 2 )                                                !==  2nd order central TIM  ==! (Eq. 23)
          DO jj = 1, jpjm1
             DO ji = 1, jpi
@@ -414,6 +412,5 @@
          CALL lbc_lnk( pt_v(:,:) , 'V',  1. )
          !
-      CASE( 3 )                                                   !==  3rd order central TIM  ==! (Eq. 24)
-         !
+      CASE( 3 )                                                !==  3rd order central TIM  ==! (Eq. 24)
          DO jj = 1, jpjm1
             DO ji = 1, jpi
@@ -428,6 +425,5 @@
          END DO
          !
-      CASE( 4 )                                                   !==  4th order central TIM  ==! (Eq. 27)
-         !
+      CASE( 4 )                                                !==  4th order central TIM  ==! (Eq. 27)
          DO jj = 1, jpjm1
             DO ji = 1, jpi
@@ -442,6 +438,5 @@
          END DO
          !
-      CASE( 5 )                                                   !==  5th order central TIM  ==! (Eq. 29)
-         !
+      CASE( 5 )                                                !==  5th order central TIM  ==! (Eq. 29)
          DO jj = 1, jpjm1
             DO ji = 1, jpi
@@ -569,10 +564,6 @@
    !!   Default option           Dummy module      NO LIM 3.0 sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   !
-   SUBROUTINE ice_adv_umx     ! Dummy routine
-      WRITE(*,*) 'ice_adv_umx: You should not have seen this print! error?'
-   END SUBROUTINE ice_adv_umx
 #endif
+
    !!======================================================================
 END MODULE iceadv_umx
